#include <iostream>
#include "Processor.h"
#include "unexpectedValue.h"
#include "Conjunto.h"

Processor::Processor(string s, Conjunto c[], char da[][100])
{
	str=s;
	pos=0;
	for(int i=0;i<100;i++)
		 ARR_CONJ[i]=c[i];
	for(int i=0;i<100;i++)
		for(int j=0;j<100;j++)
			MAT_CONJ[i][j]=da[i][j];

}

Conjunto Processor::RES_CORRECTO()
{
	return E();
}




int Processor::eval()
{ 
  try {
		E().Display();
		return 0;
  }catch( UnexpectedValue & e) {
    cerr << "Error: \n";
    cerr << str << '\n';
    for (int i=0 ; i < pos; i++) cerr << ' ';
    cerr << "^\n";
    cerr << "Se esperaba "<<e.getmsg()<< endl;
    return 0;
  }
}

Conjunto Processor::E()
{
  try {
    Conjunto t = T();
    return Ep(t);
  } catch(UnexpectedValue &e) {
    throw e;
  }
}

Conjunto Processor::Ep(Conjunto tl)
{
  Conjunto tr;
  char op;
  try {
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    op=str[pos];
    if (op!='+') return tl;
    pos++;
    tr = T();
    switch(op) {
    case '+': return(Ep(tl+tr));
    //case '-': return(Ep(tl-tr));
    }
  } catch(UnexpectedValue &e) {
    throw e;
  }
}

Conjunto Processor::T() 
{
  try {
    Conjunto f = F();
    return (Tp(f));
  }catch(UnexpectedValue &e){
    throw e;
  }
}

Conjunto Processor::Tp(Conjunto fl) 
{
  Conjunto fr;
  char op;

  try {
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    op=str[pos];
    if (op!='*') return fl;
    pos++;
    fr = F();
    switch(op) {
    case '*': return(Tp(fl*fr));
    }  
  }catch(UnexpectedValue &e) {
    throw e;
  }
}

Conjunto Processor::F() 
{
  char op;
  Conjunto result;

  while(str[pos]==' ') pos++;  // saltamos espacios en blanco
  op=str[pos];
  if (op == '(')
	{
    pos++;
    result= E();
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    if (str[pos]==')' ) 
	{
      pos++;
      return result;
    }
    else throw UnexpectedValue(" )" ,pos);
	}
  else 
  {
    char digit;
    Conjunto CONJ;
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    if ((str[pos]<'A') || ('Z' < str[pos]))
      throw UnexpectedValue("un conjunto",pos);
    while (('A'<=str[pos]) &&(str[pos]<='Z'))
	{
      for(int i=0;i<100;i++)
	  {
		  if(str[pos]==MAT_CONJ[i][0])
			  CONJ= ARR_CONJ[i];
			  
	  }
      pos++;
	  return CONJ;
    }
  }    
}


